# app.create

Create an app with app_name using catalog_app with train and version.

TODO: Add support for advanced mode which will enable users to use their own compose files

This method is a job.

Type: object

##

Type: array
No Additional Items

#### Tuple Validation

##### Parameter 1: app_create

#### app_create

Type: object

AppCreateArgs parameters.

No Additional Properties

##

#### Custom App

Type: boolean Default: false

##

#### Values

Type: object

##

#### Custom Compose Config

Type: object

##

#### Custom Compose Config String

Type: string Default: ""

##

#### Catalog App

Default: null

## Any of

Type: string
Type: null

##

#### App Name

Type: string

Application name must have the following:
1) Lowercase alphanumeric characters can be specified
2) Name must start with an alphabetic character and can end with alphanumeric character
3) Hyphen '-' is allowed but not as the first or last character
e.g abc123, abc, abcd-1232

Must match regular expression: `^[a-z]([-a-z0-9]*[a-z0-9])?$`

Must be at least `1` characters long

Must be at most `40` characters long

##

#### Train

Type: string Default: "stable"

Must be at least `1` characters long

##

#### Version

Type: string Default: "latest"

Must be at least `1` characters long

##

#### AppEntry

Type: object
No Additional Properties

##

#### Name

Type: string

Must be at least `1` characters long

##

#### Id

Type: string

Must be at least `1` characters long

##

#### State

Type: enum (of string)

##### Must be one of:

- "CRASHED"
- "DEPLOYING"
- "RUNNING"
- "STOPPED"
- "STOPPING"

##

#### Upgrade Available

Type: boolean

##

#### Latest Version

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Image Updates Available

Type: boolean

##

#### Custom App

Type: boolean

##

#### Migrated

Type: boolean

##

#### Human Version

Type: string

Must be at least `1` characters long

##

#### Version

Type: string

Must be at least `1` characters long

##

#### Metadata

Type: object

##

#### AppActiveWorkloads

Type: object
No Additional Properties

##

#### Containers

Type: integer

##

#### Used Ports

Type: array of object
No Additional Items

##### Each item of this array must be:

#### UsedPorts

Type: object
No Additional Properties

##

#### Container Port

Type: integer

##

#### Protocol

Type: string

##

#### Host Ports

Type: array of object
No Additional Items

##### Each item of this array must be:

#### HostPorts

Type: object
No Additional Properties

##

#### Host Port

Type: integer

##

#### Host Ip

Type: string

##

#### Container Details

Type: array of object
No Additional Items

##### Each item of this array must be:

#### AppContainerDetails

Type: object
No Additional Properties

##

#### Id

Type: string

##

#### Service Name

Type: string

##

#### Image

Type: string

##

#### Port Config

Type: array of object
No Additional Items

##### Each item of this array must be:

#### UsedPorts

Type: object
No Additional Properties

##

#### Container Port

Type: integer

##

#### Protocol

Type: string

##

#### Host Ports

Type: array
No Additional Items

##### Each item of this array must be:

Type: object

##

#### State

Type: enum (of string)

##### Must be one of:

- "crashed"
- "created"
- "exited"
- "running"
- "starting"

##

#### Volume Mounts

Type: array of object
No Additional Items

##### Each item of this array must be:

#### AppVolumes

Type: object
No Additional Properties

##

#### Source

Type: string

##

#### Destination

Type: string

##

#### Mode

Type: string

##

#### Type

Type: string

##

#### Volumes

Type: array of object
No Additional Items

##### Each item of this array must be:

#### AppVolumes

Type: object
No Additional Properties

##

#### Source

Type: string

##

#### Destination

Type: string

##

#### Mode

Type: string

##

#### Type

Type: string

##

#### Images

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

Must be at least `1` characters long

##

#### Networks

Type: array of object
No Additional Items

##### Each item of this array must be:

#### AppNetworks

Type: object

##

#### Name

Type: string

##

#### Id

Type: string

##

#### Labels

Type: object

##

Additional Properties of any type are allowed.

Type: object

##

#### Notes

## Any of

Type: string
Type: null

##

#### Portals

Type: object

##

#### Version Details

Default: null

## Any of

Type: object
Type: null

##

#### Config

Default: null

## Any of

Type: object
Type: null

Required roles: APPS_WRITE